/**
 * Managing Large Data, Systems Group, ETH Zurich
 * Exercise 7
 * Bitmap Indexing, Query Processing and WAH Compression
 *
 * File        : PlainBitVector.cpp
 * Author      : Cagri Balkesen, ETH Zurich, 2012-14-05
 *
 */

#include "PlainBitVector.h"

/***** Global bit operations on BitVectors *****/

/* AND operator with a temporary result */
PlainBitVector
operator& (const PlainBitVector& lhs, const PlainBitVector& rhs) 
{
    /* Assumption: vector lengths will be same. */
    PlainBitVector tmp(lhs.size());

    for(uint32_t i = 0; i < lhs.mNumWords; i++) {
        tmp.mBitWords[i] = lhs.mBitWords[i] & rhs.mBitWords[i];
    }

    return tmp;
}

/* OR operator of two PlainBitVectors in a temporary result */
PlainBitVector 
operator| (const PlainBitVector& lhs, const PlainBitVector& rhs)
{
    /* Assumption: vector lengths will be same. */
    PlainBitVector tmp(lhs.size());

    for(uint32_t i = 0; i < lhs.mNumWords; i++) {
        tmp.mBitWords[i] = lhs.mBitWords[i] | rhs.mBitWords[i];
    }

    return tmp;
}
